VERSION 5.00
Begin VB.Form Form1 
   Appearance      =   0  'Flat
   BackColor       =   &H80000005&
   Caption         =   "HRDL Visual Basic Driver"
   ClientHeight    =   4905
   ClientLeft      =   2160
   ClientTop       =   3390
   ClientWidth     =   8220
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4905
   ScaleWidth      =   8220
   Begin VB.ComboBox cboVoltage3 
      Height          =   315
      Left            =   6000
      TabIndex        =   17
      Top             =   3720
      Width           =   1455
   End
   Begin VB.ComboBox cboVoltage1 
      Height          =   315
      Left            =   6000
      TabIndex        =   16
      Top             =   3240
      Width           =   1455
   End
   Begin VB.TextBox txtTimeInterval 
      Height          =   285
      Left            =   6000
      TabIndex        =   14
      Text            =   "1000"
      Top             =   4200
      Width           =   1455
   End
   Begin VB.CommandButton Stop 
      Caption         =   "Stop Streaming"
      Height          =   495
      Left            =   6120
      TabIndex        =   11
      Top             =   2160
      Width           =   1215
   End
   Begin VB.CommandButton start 
      Caption         =   "Start Streaming"
      Height          =   495
      Left            =   6120
      TabIndex        =   10
      Top             =   1560
      Width           =   1215
   End
   Begin VB.CommandButton Close 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Close"
      Height          =   375
      Left            =   6120
      TabIndex        =   9
      Top             =   1080
      Width           =   1215
   End
   Begin VB.ListBox lstMessage 
      Appearance      =   0  'Flat
      Height          =   810
      Left            =   120
      TabIndex        =   5
      Top             =   3720
      Width           =   4095
   End
   Begin VB.ListBox lstChannel3 
      Appearance      =   0  'Flat
      Height          =   2760
      Left            =   2640
      TabIndex        =   4
      Top             =   600
      Width           =   2175
   End
   Begin VB.ComboBox conversion 
      Appearance      =   0  'Flat
      Height          =   315
      Left            =   6000
      TabIndex        =   2
      Top             =   2760
      Width           =   1455
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3600
      Top             =   1680
   End
   Begin VB.CommandButton Open 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Open"
      Height          =   375
      Left            =   6120
      TabIndex        =   1
      Top             =   480
      Width           =   1215
   End
   Begin VB.ListBox lstChannel1 
      Appearance      =   0  'Flat
      Height          =   2760
      Left            =   240
      TabIndex        =   0
      Top             =   600
      Width           =   2055
   End
   Begin VB.Label Label7 
      BackColor       =   &H80000004&
      Caption         =   "Time Interval"
      Height          =   255
      Left            =   4680
      TabIndex        =   15
      Top             =   4200
      Width           =   1215
   End
   Begin VB.Label Label5 
      BackColor       =   &H80000009&
      Caption         =   "Voltage 3"
      Height          =   255
      Left            =   5040
      TabIndex        =   13
      Top             =   3720
      Width           =   855
   End
   Begin VB.Label Label1 
      BackColor       =   &H80000009&
      Caption         =   "Voltage 1"
      Height          =   255
      Left            =   5040
      TabIndex        =   12
      Top             =   3240
      Width           =   855
   End
   Begin VB.Label Label6 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Messages"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   120
      TabIndex        =   8
      Top             =   3480
      Width           =   975
   End
   Begin VB.Label Label4 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Channel 3"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   3000
      TabIndex        =   7
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label3 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Channel 1"
      ForeColor       =   &H80000008&
      Height          =   255
      Left            =   480
      TabIndex        =   6
      Top             =   240
      Width           =   1575
   End
   Begin VB.Label Label2 
      Appearance      =   0  'Flat
      BackColor       =   &H80000005&
      Caption         =   "Conversion Time"
      ForeColor       =   &H80000008&
      Height          =   375
      Left            =   4920
      TabIndex        =   3
      Top             =   2760
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim hrdl_handle As Integer
Dim mv_1 As Single
Dim mv_3 As Single
Dim time_interval As Long
Dim time_units As Integer
Dim oversample As Integer
Dim time_indisposed As Long
Dim slow_collect As Boolean
Dim streaming As Boolean
Dim conversionTimes(5) As Integer
Dim voltage_gain(7) As Integer
Dim channelOk As Boolean



Public Sub open_unit()
Dim S As String * 10
Dim i As Integer

lstChannel1.Clear
lstChannel3.Clear
lstMessage.Clear
lstMessage.AddItem ("Opening HRDL")

hrdl_handle = HRDLOpenUnit()
If hrdl_handle > 0 Then
    lstMessage.Clear
    lstMessage.AddItem ("HRDL opened")
    
    Call Channel_select_Click

Else
    lstMessage.Clear
    lstMessage.AddItem ("Unable to open unit")
End If


End Sub

Private Sub Channel_select_Click()
Dim channel_ok As Integer


' disable all the channels
For i = 1 To 16
  Call HRDLSetAnalogInChannel(hrdl_handle, i, 0, 0, 1)
Next i

  channelOk = HRDLSetAnalogInChannel(hrdl_handle, 1, 1, cboVoltage1.ListIndex, 1)

  If channelOk = True Then
    channelOk = HRDLSetAnalogInChannel(hrdl_handle, 3, 1, cboVoltage3.ListIndex, 1)
  End If

End Sub

Private Sub Close_Click()
If (hrdl_handle > 0) Then
  If streaming = True Then
    HRDLStop (hrdl_handle)
  End If
  Call HRDLCloseUnit(hrdl_handle)
  lstMessage.Clear
  lstMessage.AddItem ("Unit closed")
  hrdl_handle = 0
Else
  lstMessage.Clear
  lstMessage.AddItem ("Unit Not Opened")
End If

End Sub

Private Sub Form_Unload(Cancel As Integer)
   Call HRDLCloseUnit(hrdl_handle)
End Sub


Private Sub start_Click()
If (hrdl_handle > 0 And Not streaming) Then
  no_of_values = 100
  Call Channel_select_Click
  If channelOk = False Then
    MsgBox "Channel Setup failed", vbOKOnly, "Error"
    Exit Sub
  End If
  conversionTime = conversion.ListIndex
  sampleInterval = Val(txtTimeInterval.Text)
  If sampleInterval < (2 * conversionTimes(conversionTime)) + 1 Then
    MsgBox "Time Interval", vbOKOnly, "Error"
    Exit Sub
  End If
     
  Call HRDLSetInterval(hrdl_handle, sampleInterval, conversionTime)
  ok = HRDLRun(hrdl_handle, no_of_values, 2)
  streaming = True
  End If
End Sub

Private Sub Stop_Click()
  If streaming = True Then
    HRDLStop (hrdl_handle)
    streaming = False
  End If
End Sub
Private Sub Form_Load()


'volage gain
voltage_gain(0) = 1
voltage_gain(1) = 2
voltage_gain(2) = 4
voltage_gain(3) = 8
voltage_gain(4) = 16
voltage_gain(5) = 32
voltage_gain(6) = 64

' conversion time in milliseconds
conversionTimes(0) = 60
conversionTimes(1) = 100
conversionTimes(2) = 180
conversionTimes(3) = 340
conversionTimes(4) = 660

'Conversion time selection as index
conversion.AddItem "60ms", 0
conversion.AddItem "100ms", 1
conversion.AddItem "180ms", 2
conversion.AddItem "340ms", 3
conversion.AddItem "660ms", 4
conversion.ListIndex = 0

'Channel
cboVoltage1.AddItem "2500mV", 0
cboVoltage1.AddItem "1250mV", 1
cboVoltage1.AddItem "625mV", 2
cboVoltage1.AddItem "313mV", 3
cboVoltage1.AddItem "156mV", 4
cboVoltage1.AddItem "78mV", 5
cboVoltage1.AddItem "39mV", 6
cboVoltage1.ListIndex = 0

cboVoltage3.AddItem "2500mV", 0
cboVoltage3.AddItem "1250mV", 1
cboVoltage3.AddItem "625mV", 2
cboVoltage3.AddItem "313mV", 3
cboVoltage3.AddItem "156mV", 4
cboVoltage3.AddItem "78mV", 5
cboVoltage3.AddItem "39mV", 6
cboVoltage3.ListIndex = 0

streaming = False

End Sub

Private Sub Open_Click()

Call open_unit

End Sub

Private Sub Timer1_Timer()
Dim ok As Integer
Dim overflow As Integer
Dim no_of_values As Long
ReDim values(100) As Long
ReDim times(100) As Long
Dim ready As Integer
Dim conversionTime As Integer
Dim sampleInterval As Integer
Dim volts_1 As Long
Dim volts_3 As Long

If Not streaming Then
  Exit Sub
End If

If HRDLReady(hrdl_handle) = 1 Then
   no_of_values = HRDLGetValues(hrdl_handle, values(0), overflow, 100)
   mv_1 = 2500 / voltage_gain(cboVoltage1.ListIndex)
   mv_3 = 2500 / voltage_gain(cboVoltage3.ListIndex)
   For i = 0 To no_of_values - 1 Step 2
        volts_1 = ((values(i) / 524288) * mv_1) * 1000
        lstChannel1.AddItem (volts_1 & Chr(9) & "uV")
        volts_3 = ((values(i + 1) / 524288) * mv_3) * 1000
        lstChannel3.AddItem (volts_3 & Chr(9) & "uV")
        
   Next i
End If

End Sub


